do
	-- TODO: Make surge warning scan for targets. Add surgewarnself and surgewarnothers
	local data = {
		version = "$Rev: 39 $",
		key = "malygos", 
		zone = "The Eye of Eternity", 
		name = "Malygos", 
		title = "Malygos", 
		tracing = {"Malygos"},
		triggers = {
			scan = "Malygos", 
		},
		onactivate = {
			autostart = true,
			autostop = true,
			leavecombat = true,
		},
		userdata = { 
			phase = 1,
			vortexcd = {29,59,loop=false},
		},
		onstart = {
			[1] = {
				{alert = "vortexcd"},
			}
		},
		alerts = {
			vortexcd = {
				var = "vortexcd", 
				varname = "Vortex cooldown", 
				type = "dropdown", 
				text = "Vortex Cooldown", 
				time = "<vortexcd>", 
				flashtime = 5, 
				sound = "ALERT1", 
				color1 = "BLUE", 
			},
			staticfieldwarn = {
				var = "staticfieldwarn", 
				varname = "Static field warning", 
				type = "simple", 
				text = "Static Field Casted. Move!", 
				time = 1.5, 
				sound = "ALERT2", 
				color1 = "YELLOW",
			},
			surgewarn = { 
				var = "surgewarn", 
				varname = "Surge warning on self", 
				type = "centerpopup", 
				text = "Surge: YOU! Careful!", 
				time = 3,
				flashtime = 3,
				sound = "ALERT1", 
				throttle = 5,
				color1 = "MAGENTA",
			},
			presurgewarn = { 
				var = "surgewarn", 
				varname = "Surge warning on self", 
				type = "simple", 
				text = "Surge: YOU! Soon!", 
				time = 1.5, 
				sound = "ALERT5", 
				color1 = "TURQUOISE",
			},
			deepbreath = {
				var = "deepbreath", 
				varname = "Deep breath", 
				type = "dropdown", 
				text = "Next Deep Breath", 
				time = 92, 
				flashtime = 5, 
				sound = "ALERT3", 
				color1 = "ORANGE", 
			},
			vortexdur = {
				var = "vortexdur", 
				varname = "Vortex duration", 
				type = "centerpopup", 
				text = "Vortex Duration", 
				time = 10, 
				sound = "ALERT1", 
				color1 = "BLUE", 
			},
			powerspark = {
				var = "powerspark", 
				varname = "Power spark", 
				type = "dropdown", 
				text = "Next Power Spark", 
				time = 17, 
				flashtime = 5, 
				sound = "ALERT2", 
				color1 = "WHITE", 
			},
		},
		events = {
			-- Vortex/Power spark
			[1] = {
				type = "combatevent", 
				eventtype = "SPELL_CAST_SUCCESS", 
				spellid = 56105, 
				execute = {
					[1] = {
						
						{alert = "vortexdur"}, 
						{alert = "vortexcd"}, 
						{quash = "powerspark"},
						{alert = "powerspark"},
					},
				},
			},
			-- Surge
			[2] = {
				type = "combatevent", 
				eventtype = "SPELL_AURA_APPLIED", 
				spellid = {57407, 60936}, 
				execute = {
					[1] = {
						{expect = {"#4#","==","&vehicleguid&"}},
						{quash = "presurgewarn"},
						{alert = "surgewarn"},
					},
				},
			},
			-- Static field
			[3] = {
				type = "combatevent", 
				eventtype = "SPELL_CAST_SUCCESS", 
				spellid = 57430, 
				execute = {
					[1] = {
						{alert = "staticfieldwarn"},
					},
				},
			},
			-- Yells
			[4] = {
				type = "event", 
				event = "CHAT_MSG_MONSTER_YELL", 
				execute = {
					[1] = {
						{expect = {"#1#", "find", "I had hoped to end your lives quickly"}},
						{quash = "vortexdur"},
						{quash = "vortexcd"},
						{quash = "powerspark"},
						{set = {phase = 2}},
						{alert = "deepbreath"},
					},
					[2] = {
						{expect = {"#1#", "find", "ENOUGH!"}},
						{quash = "deepbreath"},
						{set = {phase = 3}},
					},
				},
			},
			-- Emotes
			[5] = {
				type = "event", 
				event = "CHAT_MSG_RAID_BOSS_EMOTE", 
				execute = {
					[1] = {
						{expect = {"<phase>","==","1"}},
						{quash = "powerspark"},
						{alert = "powerspark"},
					},
					[2] = {
						{expect = {"<phase>","==","2"}},
						{alert = "deepbreath"},
					},
				},
			},
			-- Whispers
			[6] = {
				type = "event",
				event = "WHISPER",
				execute = {
					[1] = {
						{expect = {"#1#","find","fixes his eyes on you!$"}},
						{alert = "presurgewarn"},
					},
				},
			},
		},
	}

	DXE:RegisterEncounter(data)
end


